


#include "BTService_MentalState.h"

#include "BehaviorTree/BlackboardComponent.h"

UBTService_MentalState::UBTService_MentalState(const FObjectInitializer& ObjectInitializer) : Super(ObjectInitializer)
{
	INIT_SERVICE_NODE_NOTIFY_FLAGS();

	PanicKey.AddFloatFilter(this, GET_MEMBER_NAME_CHECKED(UBTService_MentalState, PanicKey));
}

void UBTService_MentalState::TickNode(UBehaviorTreeComponent& OwnerComp, uint8* NodeMemory, float DeltaSeconds)
{
	Super::TickNode(OwnerComp, NodeMemory, DeltaSeconds);

	UBlackboardComponent* BlackboardComponent = OwnerComp.GetBlackboardComponent();
	float PanicValue = BlackboardComponent->GetValueAsFloat(PanicKey.SelectedKeyName);

	PanicValue += 0.3 * DeltaSeconds;

	BlackboardComponent->SetValueAsFloat(PanicKey.SelectedKeyName, PanicValue);
}
